@echo off


rem --- get debug switch from cmd line ---
if "%1"=="d" (
	set DEBUG=true
	echo debug
) else (
	set DEBUG=false
	echo release
)



set PROJECT=perceptuum2
set BORLAND_HOME=C:\h\Borland\Bcc55
set BORLAND_BIN=%BORLAND_HOME%\bin
set OBJS_DIR=output
set INC_DIRS=%BORLAND_HOME%\include;libs
set LIB_DIRS=%BORLAND_HOME%\lib;%BORLAND_HOME%\lib\psdk;libs
set SOURCE_DIR=source
set RESOURCE_DIR=%SOURCE_DIR%\platform\ui\resources
set LIBS=import32 cw32mt libpng.lib
set STARTUP=c0w32

if "%DEBUG%"=="true" (
	set COMPILE_OPTIONS=-pr -k -5 -Od -v -y -H- -w -tWM -DWINVER=0x0400 -D_WIN32_WINNT=0x0400 -DBORLANDCPP551 -DLOGGING_ENABLED=true
	set LINK_OPTIONS=/v /m -aa -c -C -GC"{created by: harrison artifex, london, 2002 - www.hxa7241.org}" -Gn -S:0x100000 -Sc:0x10000 -H:0x2000000 -Hc:0x400000
) else (
	set COMPILE_OPTIONS=-pr -k- -5 -O2 -OS -Oc -Oi -Ov -v- -H- -w -tWM -DWINVER=0x0400 -D_WIN32_WINNT=0x0400 -DBORLANDCPP551 -DLOGGING_ENABLED=true
	set LINK_OPTIONS=-aa -c -C -GC"{created by: harrison artifex, london, 2002 - www.hxa7241.org}" -Gn -x -S:0x100000 -Sc:0x10000 -H:0x2000000 -Hc:0x400000
)



rem --- get package from cmd line ---
set PACKAGE=source
rem if not "%1"==""	(
rem 	for /D /R source %%d in (*%1) do set PACKAGE=%%~fd
rem )



rem --- clean ---
if "%PACKAGE%"=="source" (
	del /Q %OBJS_DIR%\*
)
del /Q %PROJECT%.exe %PROJECT%.tds %PROJECT%.map



rem --- make the compile list ---
dir /b /on /s %PACKAGE%\*.cpp > %PROJECT%.compile.lst

rem --- make the include list ---
for /R %SOURCE_DIR% %%i in (.) do set INC_DIRS=!INC_DIRS!;%%~fi
set INC_DIRS=-I"%INC_DIRS%"
echo %INC_DIRS% > %PROJECT%.include.lst

rem -- compile c++ and resource --
%BORLAND_BIN%\BCC32 -c -n%OBJS_DIR% @%PROJECT%.include.lst %COMPILE_OPTIONS% @%PROJECT%.compile.lst
%BORLAND_BIN%\BRCC32 -iC:\h\borland\bcc55\include -fo%OBJS_DIR%\%PROJECT%.res %RESOURCE_DIR%\%PROJECT%.rc



rem --- make the link list ---
rem (string concatenation needs dos box to be started with the /V:ON switch)
rem (see set /? and cmd /?)
set LINK_LIST=
for %%l in (%OBJS_DIR%\*.obj) do set LINK_LIST=!LINK_LIST! %%~nxl
set LINK_LIST=%LINK_LIST%, %PROJECT%.exe, , %LIBS%, , %PROJECT%.res
echo %LINK_LIST% > %PROJECT%.link.lst

rem --- link all ---
%BORLAND_BIN%\ILINK32 /j%OBJS_DIR% /I%OBJS_DIR% -L"%LIB_DIRS%" %LINK_OPTIONS% %STARTUP% @%PROJECT%.link.lst



rem --- clean temp files ---
del /Q %PROJECT%.compile.lst %PROJECT%.include.lst %PROJECT%.link.lst
if "%DEBUG%"=="false" (
	del /Q %PROJECT%.tds %PROJECT%.map
)
