/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#include "RenderData.h"


using namespace perceptuum2::control;




/// standard object services -----------------------------------------------------------------------
RenderData::RenderData()
 :	pScene_m( 0 ),
	pOptions_m( 0 ),
	pStatus_m( 0 ),
	pState_m( 0 ),
	pImage_m( 0 )
{
}


RenderData::~RenderData()
{
}




/// queries ----------------------------------------------------------------------------------------
Scene& RenderData::getScene() const
{
	return *pScene_m;
}

RenderingOptions& RenderData::getOptions() const
{
	return *pOptions_m;
}

RenderingStatus& RenderData::getStatus() const
{
	return *pStatus_m;
}

RenderingState& RenderData::getState() const
{
	return *pState_m;
}

ImageCieXyz& RenderData::getImage() const
{
	return *pImage_m;
}




/// commands ---------------------------------------------------------------------------------------
void RenderData::setScene( Scene* pScene )
{
	pScene_m = pScene;
}

void RenderData::setOptions( RenderingOptions* pOptions )
{
	pOptions_m = pOptions;
}

void RenderData::setStatus( RenderingStatus* pStatus )
{
	pStatus_m = pStatus;
}

void RenderData::setState( RenderingState* pState )
{
	pState_m = pState;
}

void RenderData::setImage( ImageCieXyz* pImage )
{
	pImage_m = pImage;
}
