/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#ifndef PixelStats_h
#define PixelStats_h


#include "Primitives.h"

#include "hxa7241_utility.h"




#include "perceptuum2_imaging.h"
namespace perceptuum2 { namespace imaging {
	using namespace hxa7241::primitives;
	using hxa7241::utility::SerializerOut;
	using hxa7241::utility::SerializerIn;


class PixelStats
{
/// standard object services -----------------------------------------------------------------------
public:
	         PixelStats();

	        ~PixelStats();
	         PixelStats( const PixelStats& );
	PixelStats& operator=( const PixelStats& );


/// commands ---------------------------------------------------------------------------------------
public:
	        void  setCount( float );
	        void  incCount();

	        void  setVariance( float );


/// queries ----------------------------------------------------------------------------------------
public:
	        float getCount()    const;
	        float getVariance() const;


/// serialization ----------------------------------------------------------------------------------
	friend  SerializerOut& operator<<( SerializerOut&, const PixelStats& );
	friend  SerializerIn&  operator>>( SerializerIn&,        PixelStats& );
	static const char* CLASS_NAME();
	static const char* CLASS_DESCRIPTION();


/// implementation ---------------------------------------------------------------------------------
private:
	        void  enforceConstraints();


/// fields -----------------------------------------------------------------------------------------
private:
	float variance_m;
	float count_m;
};




/// serialization ----------------------------------------------------------------------------------
SerializerOut& operator<<( SerializerOut&, const PixelStats& );
SerializerIn&  operator>>( SerializerIn&,        PixelStats& );


}}




#endif//PixelStats_h
