/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#ifndef ObjectInstantiator_h
#define ObjectInstantiator_h


#include "Primitives.h"
#include <string>

#include "hxa7241_utility.h"




#include "perceptuum2_modelling.h"
namespace perceptuum2 { namespace modelling {
	using namespace hxa7241::primitives;
	using hxa7241::utility::SerializerOut;
	using hxa7241::utility::SerializerIn;
	using std::string;


class ObjectInstantiator
{
/// standard object services -----------------------------------------------------------------------
public:
	         ObjectInstantiator() : objectName_m(), pObject_m( 0 ) {}

	        ~ObjectInstantiator() {}
	         ObjectInstantiator( const ObjectInstantiator& )   : objectName_m(), pObject_m( 0 ) {}
	ObjectInstantiator& operator=( const ObjectInstantiator& ) { objectName_m.clear();  pObject_m = 0;   return *this; }


/// queries ----------------------------------------------------------------------------------------
public:
	        ObjectRenderable* getObject() const { return pObject_m; }


/// serialization ----------------------------------------------------------------------------------
	friend  SerializerOut& operator<<( SerializerOut&, const ObjectInstantiator& );
	friend  SerializerIn&  input     ( SerializerIn&,        ObjectInstantiator&, Scene& );
	static const char* CLASS_NAME();
	static const char* CLASS_DESCRIPTION();


/// fields -----------------------------------------------------------------------------------------
private:
	string            objectName_m;
	ObjectRenderable* pObject_m;

};




/// serialization ----------------------------------------------------------------------------------
SerializerOut& operator<<( SerializerOut&, const ObjectInstantiator& );
SerializerIn&  input     ( SerializerIn&,        ObjectInstantiator&, const Scene& );


}}




#endif//ObjectInstantiator_h
