/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#include "ProjectableObjectRef.h"   /// own header is included last


using namespace perceptuum2::modelling;




/// standard object services -----------------------------------------------------------------------
ProjectableObjectRef::ProjectableObjectRef()
 :	pObject_m  ( 0 ),
	transform_m(),
	clipFlags_m()
{
}


ProjectableObjectRef::ProjectableObjectRef
(
	const ObjectRenderable* pObject,
	const Transclip&        transform,
	const ClipFlags         clipFlags
)
 :	pObject_m  ( pObject ),
	transform_m( transform ),
	clipFlags_m( clipFlags )
{
}


ProjectableObjectRef::~ProjectableObjectRef()
{
}


ProjectableObjectRef::ProjectableObjectRef( const ProjectableObjectRef& other )
 :	pObject_m  ( other.pObject_m ),
	transform_m( other.transform_m ),
	clipFlags_m( other.clipFlags_m )
{
}


ProjectableObjectRef& ProjectableObjectRef::operator=( const ProjectableObjectRef& other )
{
	if( &other != this )
	{
		pObject_m   = other.pObject_m;
		transform_m = other.transform_m;
		clipFlags_m = other.clipFlags_m;
	}

	return *this;
}
