/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#include "RenderingTime.h"   /// own header is included last


using namespace perceptuum2::transport;




/// standard object services -----------------------------------------------------------------------
RenderingTime::RenderingTime()
// :	begin_m( begin ),
//	end_m( end ),
//	current_m( begin )
{
	RenderingTime::set( 0.0f, 0.0f );
}


RenderingTime::RenderingTime
(
	const float begin,
	const float end
)
{
	RenderingTime::set( begin, end );
}


RenderingTime::~RenderingTime()
{
}


RenderingTime::RenderingTime( const RenderingTime& other )
{
	RenderingTime::operator=( other );
}


RenderingTime& RenderingTime::operator=( const RenderingTime& other )
{
	if( &other != this )
	{
		begin_m   = other.begin_m;
		end_m     = other.end_m;
		current_m = other.current_m;
	}

	return *this;
}




/// commands ---------------------------------------------------------------------------------------
void RenderingTime::set
(
	const float begin,
	const float end
)
{
	begin_m   = begin;
	end_m     = end;
	current_m = begin_m;
}


void RenderingTime::setTimePoint
(
	float fp01
)
{
	fp01 = fp01 >= 0.0f ? fp01 : 0.0f;
	fp01 = fp01 <= 1.0f ? fp01 : 1.0f;

	current_m = begin_m + (fp01 * (end_m - begin_m));
}




/// queries ----------------------------------------------------------------------------------------
float RenderingTime::getTime() const
{
	return current_m;
}
