/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#ifndef Random_h
#define Random_h


#include "Primitives.h"
#include "Sequence.h"




#include "hxa7241_utility.h"
namespace hxa7241 { namespace utility {
	using namespace hxa7241::primitives;


/**
 * abstract base for a random sequence.<br/><br/>
 *
 * returned values should be signed dwords in the range [MIN_VALUE, MAX_VALUE],
 * and floats in the range [0, 1).
 */
class Random
	: public Sequence
{
/// standard object services -----------------------------------------------------------------------
protected:
	         Random() {}
public:
	virtual ~Random() {}
protected:
	         Random( const Random& )   {}
	Random& operator=( const Random& ) { return *this; }


/// commands ---------------------------------------------------------------------------------------
public:
	virtual void  setSeed( dword ) =0;

	virtual void  next()           =0;


/// queries ----------------------------------------------------------------------------------------
public:
	virtual dword getDword() const =0;
	virtual float getFloat() const =0;

	virtual float getItem()  const { return getFloat(); }
};


}}




#endif//Random_h
