/*--------------------------------------------------------------------

   Perceptuum renderer, version 2.1
   Copyright (c) 2002-2003,  Harrison Ainsworth.

   www.hxa7241.org

--------------------------------------------------------------------*/

/*--------------------------------------------------------------------

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307, USA

--------------------------------------------------------------------*/


#ifndef Win32Dib_h
#define Win32Dib_h


#include "Primitives.h"
#include "stdwin.h"




#include "hxa7241_win32.h"
namespace hxa7241 { namespace win32 {
	using namespace hxa7241::primitives;


class Win32Dib
{
public:
	enum EBitsPerPixel { e8BitsPerPixel  =  8, e16BitsPerPixel = 16,
	                     e24BitsPerPixel = 24, e32BitsPerPixel = 32 };
/// standard object services -----------------------------------------------------------------------
public:
	                Win32Dib( dword width, dword height );
	                Win32Dib( dword width, dword height, dword bitsPerPixel, const RGBQUAD palette[256] =0 );

	virtual        ~Win32Dib();
private:
	                Win32Dib( const Win32Dib& );
	      Win32Dib& operator=( const Win32Dib& );


/// construction implementation --------------------------------------------------------------------
private:
	static  void constructBitmap( dword width, dword height, dword bitsPerPixel, const RGBQUAD palette[256],
	                              dword& widthInBytes, BITMAPINFO*& pBitmapInfo, HBITMAP& bitmapHandle,
	                              void*& pPixels );


/// commands ---------------------------------------------------------------------------------------
public:
	virtual void    setFrom( dword width, dword height, const dword sheet[] );


/// queries ----------------------------------------------------------------------------------------
public:
	virtual dword   getWidth()        const;
	virtual dword   getHeight()       const;
	virtual void*   getPixels()       const;
	virtual HBITMAP getBitmapHandle() const;

	virtual dword   getBitsPerPixel() const;
	virtual dword   getWidthInBytes() const;


/// fields -----------------------------------------------------------------------------------------
private:
	        BITMAPINFO*  pBitmapInfo_m;
	        HBITMAP      bitmapHandle_m;
	        void*        pPixels_m;

	        dword        widthInBytes_m;

	/// constants
	static const char CLASS_NAME[];
	static const char EXCEPTION_MESSAGE1[];
	static const char EXCEPTION_MESSAGE2[];
	static const char EXCEPTION_MESSAGE3[];
};


}}




#endif//Win32Dib_h
